<template>
  <div class="auth-container">
    <div class="row">
      <div class="col-8 mx-auto auth-form">
        <div class="img-container pb-3">
          <h3>Inscription</h3>
        </div>
        <p
          v-if="registered"
        >Votre inscription a bien été prise en compte, votre compte sera validé dans les meilleurs délais !</p>
        <b-form
          v-if="!registered"
          @submit="submitRegister"
          class="row"
          :novalidate="false"
          validated
        >
          <b-form-group label="Adresse email:" label-for="email" class="col-12">
            <b-form-input id="email" v-model="formUser.email" type="email" required></b-form-input>
          </b-form-group>
          <b-form-group label="Mot de passe" label-for="password" class="col-6">
            <b-input
              minlength="5"
              type="password"
              id="password"
              v-model="formUser.password"
              aria-describedby="password-help-block"
              required
            ></b-input>
          </b-form-group>
          <b-form-group
            label="Mot de passe (confirmation)"
            label-for="confirmPassword"
            class="col-6"
          >
            <b-input
              minlength="5"
              type="password"
              id="confirmPassword"
              v-model="formUser.confirmPassword"
              aria-describedby="password-help-block"
              required
            ></b-input>
          </b-form-group>
          <!-- Organisation ou utilisateur -->
          <section class="border col-12">
            <b-form-group label="Compte d'une organisation ?" class="col-12 toggleButtonFormGroup">
              <toggle-button
                v-model="userIsOrganisation"
                :value="true"
                :labels="{checked: 'Oui', unchecked: 'Non'}"
                color="#007bff"
              />
            </b-form-group>
            <!-- Organisation -->
            <div v-if="userIsOrganisation" class="row">
              <b-form-group label="Nom de l'organisation" label-for="label" class="col-12">
                <b-input
                  required
                  type="text"
                  id="label"
                  v-model="formUser.label"
                  aria-describedby="password-help-block"
                ></b-input>
              </b-form-group>
            </div>
            <!-- Utilisateur -->
            <div v-else class="row">
              <b-form-group label="Prénom" label-for="firstName" class="col-6">
                <b-input
                  required
                  type="text"
                  id="firstName"
                  v-model="formUser.firstName"
                  aria-describedby="password-help-block"
                ></b-input>
              </b-form-group>
              <b-form-group label="Nom de famille" label-for="lastName" class="col-6">
                <b-input
                  required
                  type="text"
                  id="lastName"
                  v-model="formUser.lastName"
                  aria-describedby="password-help-block"
                ></b-input>
              </b-form-group>
            </div>
            <p v-if="message">{{message}}</p>
          </section>
            <v-btn type="submit" class="mx-auto" color="primary mt-2">Valider</v-btn>
        </b-form>
      </div>
    </div>
  </div>
</template>
<script lang="ts">
import { Component, Vue } from "vue-property-decorator";
import UserService from "../../services/userService";
import { User } from "../../transport/User";
// import { User } from '../../transport/User';

@Component
export default class Register extends Vue {
  _userService: UserService = null;
  formUser = {} as {
    email: string;
    password: string;
    confirmPassword: string;
    label: string;
    firstName: string;
    lastName: string;
  };
  userIsOrganisation: boolean = false;
  registered = false;
  message = "";

  mounted() {
    this._userService = new UserService();
    this.resetFormUser();
  }
  submitRegister(evt) {
    evt.preventDefault();
    if (this.verifyUserOrOrganisation() && this.verifyEmail()) {
      if (!this.passwordMatch()) {
        this.message = "Les mots de passes ne correspondent pas";
      } else {
        this._userService.verifyEmail(this.formUser.email).then(() => {
          const user = new User(this.formUser);
          this._userService
            .createUser(user)
            .then(() => ((this.registered = true), (this.message = "")))
            .catch(() => (this.message = "Une erreur serveur est survenue."));
        })
        .catch(() => this.message = "L'email est déjà utilisé.");
      }
    } else {
      this.message = "L'email semble être incorrect.";
    }
  }
  /**
   * Vérifie email et mot de passe (avec vérification)
   * Renvoie un boolean: true pour valide, false pour invalide
   */
  verifyEmail(): boolean {
    var emailRegex = /\S+@\S+\.\S+/;
    return emailRegex.test(this.formUser.email);
  }

  passwordMatch(): boolean {
    return (
      this.formUser.password === this.formUser.confirmPassword &&
      this.formUser.password !== ""
    );
  }
  /**
   * Si l'utilisateur est un utilisateur, vérifie son nom et prénom
   * Si c'est une organisation, vérifie son label
   * Renvoie un boolean: true pour valide, false pour invalide
   */
  verifyUserOrOrganisation(): boolean {
    return this.userIsOrganisation
      ? this.formUser.label !== ""
      : this.formUser.firstName !== "" && this.formUser.lastName !== "";
  }
  resetFormUser() {
    this.formUser.email = "";
    this.formUser.password = "";
    this.formUser.confirmPassword = "";
    this.formUser.label = "";
    this.formUser.firstName = "";
    this.formUser.lastName = "";
  }
}
</script>
<style lang="css">
</style>
